## charls 2.3.2+dfsg

=== CMakeLists.txt ===
# Copyright (c) Team CharLS.
# SPDX-License-Identifier: BSD-3-Clause

cmake_minimum_required(VERSION 3.13...3.22)

# Extract the version info from version.h
file(READ "include/charls/version.h" version)
string(REGEX MATCH "CHARLS_VERSION_MAJOR ([0-9]*)" _ ${version})
set(version_major ${CMAKE_MATCH_1})
string(REGEX MATCH "CHARLS_VERSION_MINOR ([0-9]*)" _ ${version})
set(version_minor ${CMAKE_MATCH_1})
string(REGEX MATCH "CHARLS_VERSION_PATCH ([0-9]*)" _ ${version})
set(version_patch ${CMAKE_MATCH_1})
message(STATUS "CharLS version: ${version_major}.${version_minor}.${version_patch}")

project(charls VERSION ${version_major}.${version_minor}.${version_patch} LANGUAGES C CXX)

# Determine if project is built as a subproject (using add_subdirectory) or if it is the master project.
set(MASTER_PROJECT OFF)
if (CMAKE_CURRENT_SOURCE_DIR STREQUAL CMAKE_SOURCE_DIR)
  set(MASTER_PROJECT ON)
  message(STATUS "Building as master project, CMake version: ${CMAKE_VERSION}")
endif ()

# The basic options to control what is build extra.
option(CHARLS_BUILD_TESTS "Build test application" ${MASTER_PROJECT})
option(CHARLS_BUILD_FUZZ_TEST "Build AFL fuzzer application" ${MASTER_PROJECT})
option(CHARLS_BUILD_SAMPLES "Build sample applications" ${MASTER_PROJECT})
option(CHARLS_INSTALL "Generate the install target." ${MASTER_PROJECT})

# Provide BUILD_SHARED_LIBS as an option for GUI tools
option(BUILD_SHARED_LIBS "Will control if charls lib is build as shared lib/DLL or static library")

# These options are used by the CI pipeline to ensure new warnings are detected quickly.
# Not enabled by default to ensure the CharLS package is end-user friendly.
option(CHARLS_PEDANTIC_WARNINGS "Enable extra warnings and static analysis." OFF)
option(CHARLS_TREAT_WARNING_AS_ERROR "Treat a warning as an error." OFF)

# CharLS is written in portable c++:
set(CMAKE_CXX_EXTENSIONS OFF)

# Configure the supported C++ compilers: gcc, clang and MSVC
if(CMAKE_CXX_COMPILER_ID MATCHES "GNU")
  set(PEDANTIC_CXX_COMPILE_FLAGS
    -Wall
    -Wextra
    -pedantic
    -pedantic-errors
    -Wold-style-cast
    -Wfloat-equal
    -Wlogical-op
    -Wundef
    -Wredundant-decls
    -Wshadow
    -Wwrite-strings
    -Wpointer-arith
    -Wcast-qual
    -Wformat=2
    -Wmissing-include-dirs
    -Wcast-align
    -Wctor-dtor-privacy
    -Wdisabled-optimization
    -Winvalid-pch
    -Woverloaded-virtual
    -Wnon-virtual-dtor
    -Wnoexcept
    -Wdouble-promotion
    -Wtrampolines
    -Wzero-as-null-pointer-constant
    -Wuseless-cast
    -Wvector-operation-performance
    -Wsized-deallocation
    -Wattributes
    -Wuseless-cast
  )
  if(NOT CMAKE_CXX_COMPILER_VERSION VERSION_LESS 6.0)
      set(PEDANTIC_CXX_COMPILE_FLAGS ${PEDANTIC_CXX_COMPILE_FLAGS}
        -Wshift-overflow=2
        -Wnull-dereference
        -Wduplicated-cond
      )
  endif()
  if(NOT CMAKE_CXX_COMPILER_VERSION VERSION_LESS 8.0)
      set(PEDANTIC_CXX_COMPILE_FLAGS ${PEDANTIC_CXX_COMPILE_FLAGS}
        -Wcast-align=strict
      )
  endif()

  set(WARNINGS_AS_ERRORS_FLAG_COMPILER -Werror)
  set(WARNINGS_AS_ERRORS_FLAG_LINKER LINKER:--fatal-warnings)
endif()

if(CMAKE_CXX_COMPILER_ID MATCHES "Clang")
  set(PEDANTIC_CXX_COMPILE_FLAGS
      -Wall
      -Wextra # (-W is synonym)
      -Wnon-gcc
      -Wpedantic
      -Wcast-qual
      -Wformat=2
      -Wvla
      -Warray-bounds-pointer-arithmetic
      -Wassign-enum
      -Wbad-function-cast
      -Wconditional-uninitialized
      -Widiomatic-parentheses
      -Wimplicit-fallthrough
      -Wloop-analysis
      -Wpointer-arith
      -Wshift-sign-overflow
      -Wtautological-constant-in-range-compare
      -Wunreachable-code-aggressive
      -Wthread-safety
      -Wthread-safety-beta
      -Wcomma
      # -Weverything provides the option to discover usefull Clang warnings.
      # The list below ignores not useful Weverything warnings.
      -Wno-weak-vtables                       # Ignore, linker will remove the couple of extra vtables.
      -Wno-padded                             # Ignore, padding optimization is not needed.
      -Wno-c++98-compat                       # Ignore, CharLS 2.x targets C++14, ignore C++98 compatibility.
      -Wno-c++98-compat-pedantic              # Ignore, CharLS 2.x targets C++14, ignore C++98 compatibility.
      -Wno-global-constructors                # Ignore, by design CharLS uses types created at startup.
      -Wno-switch-enum                        # Ignore, cases are handled by default.
      -Wno-sign-conversion                    # Ignore, would just introduce ugly static_asserts.
      -Wno-exit-time-destructors              # Ignore, by design exit-time destructors are used.
      -Wno-missing-braces                     # Ignore, False warning in clang 5.0, fixed in 6.0.
  )

  if (NOT CMAKE_CXX_COMPILER_VERSION VERSION_LESS 5.0.2)
    set(PEDANTIC_CXX_COMPILE_FLAGS ${PEDANTIC_CXX_COMPILE_FLAGS}
      -Wno-undefined-func-template            # Ignore, linker will complain if final template code is not available.
    )
  endif()
  if (NOT CMAKE_CXX_COMPILER_VERSION VERSION_LESS 10.0)
    set(PEDANTIC_CXX_COMPILE_FLAGS ${PEDANTIC_CXX_COMPILE_FLAGS}
      -Walloca
    )
  endif()

  set(WARNINGS_AS_ERRORS_FLAG_COMPILER -Werror)
  if (NOT CMAKE_CXX_COMPILER_ID MATCHES "AppleClang")
    set(WARNINGS_AS_ERRORS_FLAG_LINKER LINKER:--fatal-warnings)
  endif()
endif()

if(MSVC)
  set(PEDANTIC_CXX_COMPILE_FLAGS /W4)
  set(WARNINGS_AS_ERRORS_FLAG_COMPILER /WX)
  set(WARNINGS_AS_ERRORS_FLAG_LINKER /WX)

  # Exception settings are not set for ARM(64) when building for Ninja
  string(TOLOWER ${CMAKE_CXX_COMPILER} CXX_COMPILER_LOWER)
  string(FIND ${CXX_COMPILER_LOWER} "arm" ARM_DETECTED)
  if(${ARM_DETECTED} GREATER 0)
    add_compile_options("/EHsc")
  endif()

  # Remove option /GR (/GR is added by default by CMake). /GR is already the default
  # and this makes it possible to use /GR- without warnings.
  string(REGEX REPLACE " /GR" "" CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS}")

  # All C and C++ source files are in utf-8 without signature (bom), MSVC requires utf-8 switch to read files correctly.
  add_compile_options("/utf-8")

  # Zc:__cplusplus: Will configure the MSVC compiler to use the correct value for the __cplusplus macro
  # This option is introduced with Visual Studio 2017 version 15.7
  if(MSVC_VERSION GREATER_EQUAL 1914)
    add_compile_options("/Zc:__cplusplus")
  endif()

  # /Zc:throwingNew: Will configure the MSVC compiler that only the standard throwing operator new is used.
  add_compile_options("/Zc:throwingNew")

  # /permissive-: Will configure the MSVC compiler to accept only standards conformance C++
  # This option is introduced with Visual Studio 2017.
  if(MSVC_VERSION GREATER_EQUAL 1910)
    add_compile_options("/permissive-")
  endif()

  # /ZH:SHA_256: Wiill use SHA 256 for checksums between source code and debug symbols (more secure)
  add_compile_options("/ZH:SHA_256")

  # /guard:cf: Will enable Control Flow Guard, which provides addition compile time and runtime checks.
  add_compile_options("/guard:cf")
  add_link_options("/guard:cf")

  # /CETCOMPAT: Mark executable image compatible with the Control-flow Enforcement Technology (CET) Shadow Stack.
  # CET is only supported by x64 and x86 CPUs (11th generation Intel and AMD Zen3 and newer)
  if(${ARM_DETECTED} EQUAL 0)
    add_link_options("/CETCOMPAT")
  endif()

endif()

# When enabled apply the pedantic warnings options and warnings as errors to globally.
if(CHARLS_PEDANTIC_WARNINGS)
  if(MSVC)
    # Remove existing warning level (W3 is added by default by CMake), duplicate level will generate cmd-line warnings.
    string(REGEX REPLACE " /W[0-4]" "" CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS}")
  endif()

  add_compile_options("$<$<COMPILE_LANGUAGE:CXX>:${PEDANTIC_CXX_COMPILE_FLAGS}>")
endif()

if(CHARLS_TREAT_WARNING_AS_ERROR)
  add_compile_options(${WARNINGS_AS_ERRORS_FLAG_COMPILER})
  add_link_options(${WARNINGS_AS_ERRORS_FLAG_LINKER})
endif()

include(src/CMakeLists.txt)

if(CHARLS_BUILD_TESTS)
  add_subdirectory(test)
endif()

if(CHARLS_BUILD_FUZZ_TEST)
  add_subdirectory(fuzztest)
endif()

if(CHARLS_BUILD_SAMPLES)
  add_subdirectory(samples)
endif()

=== debian/changelog ===
charls (2.3.2+dfsg-1) unstable; urgency=medium

  * Team upload.
  * New upstream version 2.3.2+dfsg

 -- Mathieu Malaterre <malat@debian.org>  Mon, 31 Jan 2022 13:40:42 +0100

=== debian/control ===
Source: charls
Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
Uploaders: Andreas Tille <tille@debian.org>,
           Shayan Doust <hello@shayandoust.me>
Section: science
Priority: optional
Build-Depends: cmake,
               debhelper-compat (= 13)
Standards-Version: 4.6.0
Vcs-Browser: https://salsa.debian.org/med-team/charls
Vcs-Git: https://salsa.debian.org/med-team/charls.git
Homepage: https://github.com/team-charls/charls
Rules-Requires-Root: no

Package: libcharls-dev
Architecture: any
Multi-Arch: same
Section: libdevel
Depends: libcharls2 (= ${binary:Version}),
         ${misc:Depends}
Breaks: libdcmtk-dev (<< 3.6.5-1~)
Replaces: libdcmtk-dev (<< 3.6.5-1~)
Description: Implementation of the JPEG-LS standard (development libraries)
 CharLS is an optimized implementation of the JPEG-LS standard for lossless and
 near-lossless image compression
 .
 JPEG-LS (ISO-14495-1/ITU-T.87) is a standard derived from the Hewlett Packard
 LOCO algorithm. JPEG LS has low complexity (meaning fast compression) and high
 compression ratios, similar to JPEG 2000. JPEG-LS is more similar to the old
 Lossless JPEG than to JPEG 2000, but interestingly the two different techniques
 result in vastly different performance characteristics.
 .
 This package contains the development files.

Package: libcharls2
Architecture: any
Multi-Arch: same
Section: libs
Depends: ${misc:Depends},
         ${shlibs:Depends}
Pre-Depends: ${misc:Pre-Depends}
Description: Implementation of the JPEG-LS standard
 CharLS is an optimized implementation of the JPEG-LS standard for lossless and
 near-lossless image compression
 .
 JPEG-LS (ISO-14495-1/ITU-T.87) is a standard derived from the Hewlett Packard
 LOCO algorithm. JPEG LS has low complexity (meaning fast compression) and high
 compression ratios, similar to JPEG 2000. JPEG-LS is more similar to the old
 Lossless JPEG than to JPEG 2000, but interestingly the two different techniques
 result in vastly different performance characteristics.

=== debian/rules ===
#!/usr/bin/make -f
#export DH_VERBOSE=1

include /usr/share/dpkg/default.mk

export DEB_BUILD_MAINT_OPTIONS = hardening=+all
export DPKG_GENSYMBOLS_CHECK_LEVEL = 4

# SAMPLES should not be installed:
# https://github.com/team-charls/charls/blob/master/samples/README.md
CMAKE_EXTRA_FLAGS += \
 -DBUILD_SHARED_LIBS:BOOL=ON \
 -DCHARLS_BUILD_SAMPLES:BOOL=ON \
 -DCHARLS_BUILD_TESTS:BOOL=ON \
 -DCHARLS_PEDANTIC_WARNINGS:BOOL=ON

%:
	dh $@ --buildsystem=cmake

override_dh_auto_configure:
	dh_auto_configure -- $(CMAKE_EXTRA_FLAGS)

pkg_run = libcharls2
pkg_dev = libcharls-dev

override_dh_install-arch:
	# Runtime Package
	dh_install -p$(pkg_run) usr/lib/$(DEB_HOST_MULTIARCH)/lib*.so.*
	# Development Package
	dh_install -p$(pkg_dev) usr/include
	dh_install -p$(pkg_dev) usr/lib/$(DEB_HOST_MULTIARCH)/lib*.so
	dh_install -p$(pkg_dev) usr/lib/$(DEB_HOST_MULTIARCH)/cmake/charls/*.cmake
	dh_install -p$(pkg_dev) usr/lib/$(DEB_HOST_MULTIARCH)/pkgconfig/charls.pc
	# See #971425, #971431 & #971435:
	dh_link -p$(pkg_run) usr/lib/$(DEB_HOST_MULTIARCH)/libcharls.so.2 usr/lib/$(DEB_HOST_MULTIARCH)/libCharLS.so.2
	dh_link -p$(pkg_dev) usr/lib/$(DEB_HOST_MULTIARCH)/libcharls.so usr/lib/$(DEB_HOST_MULTIARCH)/libCharLS.so
	dh_link -p$(pkg_dev) usr/include/charls usr/include/CharLS
#	dh_install -a
#	d-shlibmove --commit \
#		     --multiarch \
#		     --devunversioned \
#		     --movedev debian/tmp/usr/include/* usr/include \
#		     debian/tmp/usr/lib/*/*.so

## charls 2.3.3+dfsg

=== debian/changelog ===
charls (2.3.3+dfsg-1) unstable; urgency=medium

  * Team upload.
  * New upstream version 2.3.3+dfsg. Closes: #1004842

 -- Mathieu Malaterre <malat@debian.org>  Mon, 07 Feb 2022 09:26:50 +0100

=== debian/rules ===
--- 
+++ 
@@ -20,6 +20,9 @@
 override_dh_auto_configure:
 	dh_auto_configure -- $(CMAKE_EXTRA_FLAGS)
 
+override_dh_auto_test-arch:
+	dh_auto_test || true
+
 pkg_run = libcharls2
 pkg_dev = libcharls-dev

## charls 2.3.4

=== CMakeLists.txt ===
--- 
+++ 
@@ -210,7 +210,15 @@
 include(src/CMakeLists.txt)
 
 if(CHARLS_BUILD_TESTS)
+  enable_testing()
   add_subdirectory(test)
+
+  # The unit tests project depends on the VS C++ unit test framework. Use the -unittest option of the charlstest tool for other platforms.
+  add_test(
+    NAME basic-test
+    COMMAND charlstest -unittest
+    WORKING_DIRECTORY ${CMAKE_CURRENT_LIST_DIR}
+  )
 endif()
 
 if(CHARLS_BUILD_FUZZ_TEST)

=== fuzztest/CMakeLists.txt ===
# Copyright (c) Team CharLS.
# SPDX-License-Identifier: BSD-3-Clause

add_executable(fuzztest "")

target_sources(fuzztest PRIVATE main.cpp)

set_target_properties(fuzztest PROPERTIES CXX_VISIBILITY_PRESET hidden)

target_link_libraries(fuzztest PRIVATE charls)

if(MSVC)
  # POSIX functions are used, required for AFL.
  target_compile_definitions(fuzztest PRIVATE _CRT_SECURE_NO_WARNINGS)
endif()

=== src/CMakeLists.txt ===
# Copyright (c) Team CharLS.
# SPDX-License-Identifier: BSD-3-Clause

# Define the library "charls" target
add_library(charls "")

# Enable IPO (Interprocedural optimization) for shared lib in release mode with GCC for better performance.
# Note: MSVC and Clang will create with IPO larger binaries that are not significant faster.
if(BUILD_SHARED_LIBS AND CMAKE_CXX_COMPILER_ID MATCHES "GNU")
  include(CheckIPOSupported)
  check_ipo_supported(RESULT ipo_supported)
  if(ipo_supported)
      message("-- IPO is supported and used")
      set_property(TARGET charls PROPERTY INTERPROCEDURAL_OPTIMIZATION_RELEASE TRUE)
  else()
      message("-- IPO is not supported")
  endif()
endif()

target_include_directories(charls PUBLIC
  $<BUILD_INTERFACE:${charls_SOURCE_DIR}/include>
  $<INSTALL_INTERFACE:include>)

if(NOT BUILD_SHARED_LIBS)
  target_compile_definitions(charls PUBLIC CHARLS_STATIC)
endif()

if(WIN32 AND BUILD_SHARED_LIBS)
  if(CMAKE_SIZEOF_VOID_P EQUAL 8)
    set_target_properties(charls PROPERTIES OUTPUT_NAME "charls-2-x64")
  else()
    set_target_properties(charls PROPERTIES OUTPUT_NAME "charls-2-x86")
  endif()
endif()

# Disable C++ run-time type info (dynamic cast + typeid). CharLS doesn't use
# this functionality and disabling it will result in a smaller image.
# Don't do this for gcc and clang (normally done with -fno-rtti) as it will cause
# UBSAN warnings as jpegls_category is derived from std::error_category
# If the base class was built with RTTI and has virtual functions, the derived class
# also needs to be build with RTTI.
if(MSVC)
  target_compile_options(charls PRIVATE /GR-)
endif()

set_target_properties(charls PROPERTIES
                      VERSION ${PROJECT_VERSION}
                      SOVERSION ${PROJECT_VERSION_MAJOR})

target_compile_definitions(charls PRIVATE CHARLS_LIBRARY_BUILD)
# CharLS requires C++14 or newer.
target_compile_features(charls PUBLIC cxx_std_14)

set(HEADERS
    "include/charls/api_abi.h"
    "include/charls/annotations.h"
    "include/charls/charls.h"
    "include/charls/charls_jpegls_decoder.h"
    "include/charls/charls_jpegls_encoder.h"
    "include/charls/jpegls_error.h"
    "include/charls/public_types.h"
    "include/charls/version.h"
)
foreach(header HEADERS)
  list(APPEND CHARLS_PUBLIC_HEADER $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/${header}>)
  list(APPEND CHARLS_PUBLIC_HEADER $<INSTALL_INTERFACE:${header}>)
endforeach()

set_target_properties(charls PROPERTIES CXX_VISIBILITY_PRESET hidden)
set_target_properties(charls PROPERTIES VISIBILITY_INLINES_HIDDEN 1)
set_property(TARGET charls PROPERTY PUBLIC_HEADER ${HEADERS})

set_target_properties(charls PROPERTIES
  LINK_DEPENDS ${CMAKE_CURRENT_LIST_DIR}/charls.version)
if(UNIX AND NOT APPLE)
  set_property(TARGET charls APPEND_STRING PROPERTY
    LINK_FLAGS " -Wl,--version-script=${CMAKE_CURRENT_LIST_DIR}/charls.version")
endif()

target_sources(charls
  PUBLIC
    ${CHARLS_PUBLIC_HEADERS}
  PRIVATE
    "${CMAKE_CURRENT_LIST_DIR}/byte_span.h"
    "${CMAKE_CURRENT_LIST_DIR}/charls_jpegls_decoder.cpp"
    "${CMAKE_CURRENT_LIST_DIR}/charls_jpegls_encoder.cpp"
    "${CMAKE_CURRENT_LIST_DIR}/coding_parameters.h"
    "${CMAKE_CURRENT_LIST_DIR}/color_transform.h"
    "${CMAKE_CURRENT_LIST_DIR}/conditional_static_cast.h"
    "${CMAKE_CURRENT_LIST_DIR}/constants.h"
    "${CMAKE_CURRENT_LIST_DIR}/context_regular_mode.h"
    "${CMAKE_CURRENT_LIST_DIR}/context_run_mode.h"
    "${CMAKE_CURRENT_LIST_DIR}/decoder_strategy.h"
    "${CMAKE_CURRENT_LIST_DIR}/default_traits.h"
    "${CMAKE_CURRENT_LIST_DIR}/encoder_strategy.h"
    "${CMAKE_CURRENT_LIST_DIR}/jls_codec_factory.h"
    "${CMAKE_CURRENT_LIST_DIR}/jpegls_error.cpp"
    "${CMAKE_CURRENT_LIST_DIR}/jpegls.cpp"
    "${CMAKE_CURRENT_LIST_DIR}/jpeg_marker_code.h"
    "${CMAKE_CURRENT_LIST_DIR}/jpegls_preset_coding_parameters.h"
    "${CMAKE_CURRENT_LIST_DIR}/jpegls_preset_parameters_type.h"
    "${CMAKE_CURRENT_LIST_DIR}/jpeg_stream_reader.cpp"
    "${CMAKE_CURRENT_LIST_DIR}/jpeg_stream_writer.cpp"
    "${CMAKE_CURRENT_LIST_DIR}/lookup_table.h"
    "${CMAKE_CURRENT_LIST_DIR}/lossless_traits.h"
    "${CMAKE_CURRENT_LIST_DIR}/process_line.h"
    "${CMAKE_CURRENT_LIST_DIR}/scan.h"
    "${CMAKE_CURRENT_LIST_DIR}/util.h"
    "${CMAKE_CURRENT_LIST_DIR}/version.cpp"
)

if(WIN32 AND BUILD_SHARED_LIBS)
  # Only add the Win32 resource script file when building a DLL
  target_sources(charls PRIVATE "${CMAKE_CURRENT_LIST_DIR}/charls.rc")

  # Only add the definition file when building a x86 DLL with MSVC
  # The definition file is needed to ensure the legacy functions are exported with the correct name
  if(MSVC AND CMAKE_SIZEOF_VOID_P EQUAL 4)
    target_sources(charls PRIVATE "${CMAKE_CURRENT_LIST_DIR}/charls.def")
  endif()
endif()

if(CHARLS_INSTALL)
  include(GNUInstallDirs)
  include(CMakePackageConfigHelpers)

  install(TARGETS charls EXPORT charls_targets
    RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
    LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
    ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
    PUBLIC_HEADER DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/charls
  )

  write_basic_package_version_file(${CMAKE_CURRENT_BINARY_DIR}/charlsConfigVersion.cmake COMPATIBILITY SameMajorVersion)

  # Configure and copy the pkg-config configuration file.
  # These type of configuration file can make it easier to detect if charls is installed.
  CONFIGURE_FILE("${CMAKE_CURRENT_LIST_DIR}/charls-template.pc" "charls.pc" @ONLY)
  install(FILES "${CMAKE_CURRENT_BINARY_DIR}/charls.pc" DESTINATION "${CMAKE_INSTALL_LIBDIR}/pkgconfig")

  install(FILES "${CMAKE_CURRENT_BINARY_DIR}/charlsConfigVersion.cmake" DESTINATION "${CMAKE_INSTALL_LIBDIR}/cmake/charls")

  install(EXPORT charls_targets FILE charlsConfig.cmake DESTINATION ${CMAKE_INSTALL_LIBDIR}/cmake/charls)
endif()

=== test/CMakeLists.txt ===
# Copyright (c) Team CharLS.
# SPDX-License-Identifier: BSD-3-Clause

add_executable(charlstest "")

target_sources(charlstest
  PRIVATE
    bitstreamdamage.cpp
    bitstreamdamage.h
    compliance.cpp
    compliance.h
    dicomsamples.cpp
    dicomsamples.h
    main.cpp
    performance.cpp
    performance.h
    util.cpp
    util.h
    legacy.cpp
    legacy.h
)

if(WIN32 AND MSVC_VERSION GREATER_EQUAL 1920)
  # Only add the manifest file when building a Windows app
  target_sources(charlstest PRIVATE app.manifest)
endif()

set_target_properties(charlstest PROPERTIES CXX_VISIBILITY_PRESET hidden)

target_link_libraries(charlstest PRIVATE charls)

=== samples/convert.c/CMakeLists.txt ===
# Copyright (c) Team CharLS.
# SPDX-License-Identifier: BSD-3-Clause

add_executable(convert-c "")

target_sources(convert-c
  PRIVATE
    main.c
)

if(WIN32 AND MSVC_VERSION GREATER_EQUAL 1920)
  # Only add the manifest file when building a Windows app
  target_sources(convert-c PRIVATE app.manifest)
endif()

target_link_libraries(convert-c PRIVATE charls)

if(MSVC)
  # Not all compilers come with the secure C standard extension functions, making it difficult to use them.
  # Disable the MSVC warning about not using these functions to keep the sample code simple and easy to understand.
  target_compile_definitions(convert-c PRIVATE _CRT_SECURE_NO_WARNINGS)
endif()

=== debian/changelog ===
charls (2.3.4-1) unstable; urgency=medium

  * Team upload.
  * New upstream version 2.3.4
  * d/copyright: Include all binary files from upstream
  * d/rules: Make sure to check return code of test

 -- Mathieu Malaterre <malat@debian.org>  Thu, 17 Feb 2022 09:11:23 +0100

=== debian/watch ===
version=4

opts="repacksuffix=+dfsg,dversionmangle=s/\+dfsg//g,repack,compression=xz" \
   https://github.com/team-charls/charls/releases .*/([\d.-]+)\.(?:tar(?:\.gz|\.bz2)?|tgz)

## charls 2.4.1

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -25,9 +25,14 @@
   target_compile_definitions(charls PUBLIC CHARLS_STATIC)
 endif()
 
+# Use different DLL filenames on Windows. It allows platform neutral adapters to load dynamicly the correct version.
 if(WIN32 AND BUILD_SHARED_LIBS)
   if(CMAKE_SIZEOF_VOID_P EQUAL 8)
-    set_target_properties(charls PROPERTIES OUTPUT_NAME "charls-2-x64")
+    if(CMAKE_CXX_COMPILER_ARCHITECTURE_ID MATCHES "ARM64")
+      set_target_properties(charls PROPERTIES OUTPUT_NAME "charls-2-arm64")
+    else()
+      set_target_properties(charls PROPERTIES OUTPUT_NAME "charls-2-x64")
+    endif()
   else()
     set_target_properties(charls PROPERTIES OUTPUT_NAME "charls-2-x86")
   endif()
@@ -59,6 +64,7 @@
     "include/charls/charls_jpegls_encoder.h"
     "include/charls/jpegls_error.h"
     "include/charls/public_types.h"
+    "include/charls/validate_spiff_header.h"
     "include/charls/version.h"
 )
 foreach(header HEADERS)
@@ -106,6 +112,7 @@
     "${CMAKE_CURRENT_LIST_DIR}/process_line.h"
     "${CMAKE_CURRENT_LIST_DIR}/scan.h"
     "${CMAKE_CURRENT_LIST_DIR}/util.h"
+    "${CMAKE_CURRENT_LIST_DIR}/validate_spiff_header.cpp"
     "${CMAKE_CURRENT_LIST_DIR}/version.cpp"
 )

=== samples/convert.cpp/CMakeLists.txt ===
# Copyright (c) Team CharLS.
# SPDX-License-Identifier: BSD-3-Clause

add_executable(convert-cpp "")

target_sources(convert-cpp
  PRIVATE
    pch.h
    bmp_image.h
    main.cpp
)

if(WIN32 AND MSVC_VERSION GREATER_EQUAL 1920)
  # Only add the manifest file when building a Windows app
  target_sources(convert-cpp PRIVATE app.manifest)
endif()

set_target_properties(convert-cpp PROPERTIES CXX_VISIBILITY_PRESET hidden)

target_link_libraries(convert-cpp PRIVATE charls)

=== debian/changelog ===
charls (2.4.1-1) unstable; urgency=medium

  * Team upload.
  * New upstream version 2.4.1
  * d/symbols: Add new symbols

 -- Mathieu Malaterre <malat@debian.org>  Thu, 19 Jan 2023 16:14:14 +0100

charls (2.3.4-2) unstable; urgency=medium

  * Fix watch file
  * Standards-Version: 4.6.1 (routine-update)

 -- Andreas Tille <tille@debian.org>  Tue, 06 Dec 2022 18:06:56 +0100

=== debian/control ===
--- 
+++ 
@@ -6,7 +6,7 @@
 Priority: optional
 Build-Depends: cmake,
                debhelper-compat (= 13)
-Standards-Version: 4.6.0
+Standards-Version: 4.6.1
 Vcs-Browser: https://salsa.debian.org/med-team/charls
 Vcs-Git: https://salsa.debian.org/med-team/charls.git
 Homepage: https://github.com/team-charls/charls

=== debian/rules ===
--- 
+++ 
@@ -21,7 +21,7 @@
 	dh_auto_configure -- $(CMAKE_EXTRA_FLAGS)
 
 override_dh_auto_test-arch:
-	dh_auto_test || true
+	dh_auto_test
 
 pkg_run = libcharls2
 pkg_dev = libcharls-dev

=== debian/watch ===
version=4

opts="repacksuffix=+dfsg,dversionmangle=auto,filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%@PACKAGE@-$1.tar.gz%" \
   https://github.com/team-charls/charls/tags .*/([\d.-]+)\.(?:tar(?:\.gz|\.bz2)?|tgz)

## charls 2.4.2

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,7 +1,7 @@
 # Copyright (c) Team CharLS.
 # SPDX-License-Identifier: BSD-3-Clause
 
-cmake_minimum_required(VERSION 3.13...3.22)
+cmake_minimum_required(VERSION 3.13...3.25)
 
 # Extract the version info from version.h
 file(READ "include/charls/version.h" version)
@@ -72,6 +72,7 @@
     -Wsized-deallocation
     -Wattributes
     -Wuseless-cast
+    -Wconversion
   )
   if(NOT CMAKE_CXX_COMPILER_VERSION VERSION_LESS 6.0)
       set(PEDANTIC_CXX_COMPILE_FLAGS ${PEDANTIC_CXX_COMPILE_FLAGS}
@@ -113,6 +114,7 @@
       -Wthread-safety
       -Wthread-safety-beta
       -Wcomma
+      -Wconversion
       # -Weverything provides the option to discover usefull Clang warnings.
       # The list below ignores not useful Weverything warnings.
       -Wno-weak-vtables                       # Ignore, linker will remove the couple of extra vtables.

=== samples/CMakeLists.txt ===
# Copyright (c) Team CharLS.
# SPDX-License-Identifier: BSD-3-Clause

add_subdirectory(convert.c)
add_subdirectory(convert.cpp)

=== debian/changelog ===
charls (2.4.2-2build2) noble; urgency=medium

  * No change rebuild for frame pointers (and time_t).

 -- Matthias Klose <doko@ubuntu.com>  Fri, 19 Apr 2024 20:14:52 +0200

charls (2.4.2-2build1) noble; urgency=high

  * No change rebuild for frame pointers (and time_t).

 -- Julian Andres Klode <juliank@ubuntu.com>  Thu, 18 Apr 2024 19:51:46 +0200

charls (2.4.2-2) unstable; urgency=medium

  * Team upload.
  * d/maintscript: Remove leftover
  * d/rules: Migrate to ninja build
  * d/control: Bump Std-Vers to 4.6.2 no changes needed

 -- Mathieu Malaterre <malat@debian.org>  Mon, 30 Oct 2023 15:56:47 +0100

charls (2.4.2-1) unstable; urgency=medium

  * Team upload.
  * d/rules: Start using LTO
  * New upstream version 2.4.2
  * d/rules: Remove old compat symlinks (oldstable)

 -- Mathieu Malaterre <malat@debian.org>  Thu, 12 Oct 2023 16:16:16 +0200

=== debian/control ===
--- 
+++ 
@@ -1,12 +1,12 @@
 Source: charls
-Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
 Uploaders: Andreas Tille <tille@debian.org>,
            Shayan Doust <hello@shayandoust.me>
 Section: science
 Priority: optional
-Build-Depends: cmake,
-               debhelper-compat (= 13)
-Standards-Version: 4.6.1
+Build-Depends: cmake, debhelper-compat (= 13), ninja-build
+Standards-Version: 4.6.2
 Vcs-Browser: https://salsa.debian.org/med-team/charls
 Vcs-Git: https://salsa.debian.org/med-team/charls.git
 Homepage: https://github.com/team-charls/charls
@@ -16,8 +16,7 @@
 Architecture: any
 Multi-Arch: same
 Section: libdevel
-Depends: libcharls2 (= ${binary:Version}),
-         ${misc:Depends}
+Depends: libcharls2 (= ${binary:Version}), ${misc:Depends}
 Breaks: libdcmtk-dev (<< 3.6.5-1~)
 Replaces: libdcmtk-dev (<< 3.6.5-1~)
 Description: Implementation of the JPEG-LS standard (development libraries)
@@ -36,8 +35,7 @@
 Architecture: any
 Multi-Arch: same
 Section: libs
-Depends: ${misc:Depends},
-         ${shlibs:Depends}
+Depends: ${misc:Depends}, ${shlibs:Depends}
 Pre-Depends: ${misc:Pre-Depends}
 Description: Implementation of the JPEG-LS standard
  CharLS is an optimized implementation of the JPEG-LS standard for lossless and

=== debian/rules ===
#!/usr/bin/make -f
#export DH_VERBOSE=1

include /usr/share/dpkg/default.mk

export DEB_BUILD_MAINT_OPTIONS = hardening=+all optimize=+lto
export DPKG_GENSYMBOLS_CHECK_LEVEL = 4

# SAMPLES should not be installed:
# https://github.com/team-charls/charls/blob/master/samples/README.md
CMAKE_EXTRA_FLAGS += \
 -DBUILD_SHARED_LIBS:BOOL=ON \
 -DCHARLS_BUILD_SAMPLES:BOOL=ON \
 -DCHARLS_BUILD_TESTS:BOOL=ON \
 -DCHARLS_PEDANTIC_WARNINGS:BOOL=ON

%:
	dh $@ --buildsystem=cmake+ninja

override_dh_auto_configure:
	dh_auto_configure -- $(CMAKE_EXTRA_FLAGS)

override_dh_auto_test-arch:
	dh_auto_test

pkg_run = libcharls2
pkg_dev = libcharls-dev

override_dh_install-arch:
	# Runtime Package
	dh_install -p$(pkg_run) usr/lib/$(DEB_HOST_MULTIARCH)/lib*.so.*
	# Development Package
	dh_install -p$(pkg_dev) usr/include
	dh_install -p$(pkg_dev) usr/lib/$(DEB_HOST_MULTIARCH)/lib*.so
	dh_install -p$(pkg_dev) usr/lib/$(DEB_HOST_MULTIARCH)/cmake/charls/*.cmake
	dh_install -p$(pkg_dev) usr/lib/$(DEB_HOST_MULTIARCH)/pkgconfig/charls.pc
